/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is WebMail Notifier.
 *
 * The Initial Developer of the Original Code is
 * Byungwook Kang.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

const dout=Components.utils.reportError;

const Ci=Components.interfaces;
var hostStr=["","","","nate.com","gmail.com","","hotmail.com"];
var prefBranch;
var prefService;
var accountsChanged=false;
var rebuildTree=false;
var arDefault;
var arAccounts;
var arDeleted;
var keyNum;
var autoLogin;
var wmn;

function onAccept() {
  if(accountsChanged){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService);
    for each(var o in arDeleted){//check deleted accounts;
      wmn.removePassword("chrome://wm-notifier/webmail"+o.host,o.user);
      var s="wm-notifier.webmail"+o.host+"."+o.user;
      try{ prefBranch.deleteBranch(s); }catch(e){}
    }
    if(arDeleted)prefService.savePrefFile(null);
  }
  if(accountsChanged||rebuildTree){
    for(var i in arDefault){//check default accounts
      var str="wm-notifier.webmail"+i+".default";
      var t=null;
      try{
        t=prefBranch.getCharPref(str);
      }catch(e){}
      if(t!=arDefault[i]){
        if(arDefault[i])prefBranch.setCharPref(str,arDefault[i]);
        else prefBranch.clearUserPref(str);
      }
    }
    for each(var o in arAccounts){//check newly added accounts
      var prefStr="wm-notifier.webmail"+o.host+"."+o.user+".enabled";
      var t=null;
      try{
        t=prefBranch.getBoolPref(prefStr);
      }catch(e){}
      if(t!=o.enabled){
        prefBranch.setBoolPref(prefStr,o.enabled);
      }
    }
    if(accountsChanged){
      for each(var o in arAccounts){
        if(o.isNew)wmn.setPassword("chrome://wm-notifier/webmail"+o.host,o.user,o.passwd);
      }
    }
  }
  var val=document.getElementById("autologin").checked?1:0;
  if(val!=autoLogin){
    var str="chrome://wm-notifier/options";
    var str2="autoLogin";
    wmn.setIntValue(str2,val);
    wmn.setPassword(str,str2,val);
  }
  if(accountsChanged){
    wmn.initHandlers(true);
  }else if(rebuildTree){
    wmn.buildTable(true);
  }
  return false;
}
function onCancel(){
  if((prefBranch.getBoolPref("browser.preferences.instantApply"))){//not window. close button only
    onAccept();
  }
}
function onLoad() {
  if(!checkMasterPasswords()){
    window.close();
    return;
  }
  wmn = Components.classes["@mozilla.org/WebMailNotifier;1"]
              .getService(Ci.nsIWebMailNotifier);
  keyNum=0;
  prefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Ci.nsIPrefService);
  prefBranch = prefService.getBranch("");
  prefBranch.QueryInterface(Ci.nsIPrefBranch2);

  arDefault=[];
  arAccounts=[];
  arDeleted=[];
  var obj=document.getElementById("wmn-hosts");
  var hosts=prefBranch.getIntPref("wm-notifier.hosts");
  for(var i=0;i<hosts;i++){
    var s=getHostName(i);
    if(s==null)continue;
    obj.appendItem(s,i,"");
    try{
      arDefault[i]=prefBranch.getCharPref("wm-notifier.webmail"+i+".default");
    }catch(e){}
  }
  obj.selectedIndex=0;
  var n=wmn.getAccountsNumber();
  for(var i=0;i<n;i++){
    var ar=wmn.getAccountInfo({},i);
    addItem(ar[0],ar[1],ar[2],false);
  }
  checkDefault();
  autoLogin=wmn.getIntValue("autoLogin");
  document.getElementById("autologin").checked=autoLogin;
}
function getHostName(host){
  var s="webmail"+host;
  try{
    return this.getString(s);
  }catch(e){}
  var t=wmn.getHostName(host);
  if(t==null)return null;
  return t?t:s;
}
function addItem(host,user,passwd,isNew){
  var key=keyNum++;
  var prefStr="wm-notifier.webmail"+host+"."+user+".enabled";
  var enabled=true;
  try{
    enabled=prefBranch.getBoolPref(prefStr);
  }catch(e){}
  arAccounts.push({"host":host,"user":user,"passwd":passwd,"enabled":enabled,"key":key,"isNew":isNew});

  var obj = document.createElement("listitem");
  obj.setAttribute("allowevents","true");
    var ch = document.createElement("listcell");
      var ch1 = document.createElement("vbox");
      ch1.setAttribute("flex","1");
      ch1.setAttribute("align","center");
        var ch2 = document.createElement("checkbox");
        ch2.setAttribute("checked",enabled);
        ch2.setAttribute("onclick","setEnabled(this.checked,"+key+")");
        ch1.appendChild(ch2);
      ch.appendChild(ch1);
    obj.appendChild(ch);
    ch = document.createElement("listcell");
    ch.setAttribute("label",this.getHostName(host));
    obj.appendChild(ch);
    ch = document.createElement("listcell");
    ch.setAttribute("label",user);
    obj.appendChild(ch);
    ch = document.createElement("listcell");
      var ch1 = document.createElement("vbox");
      ch1.setAttribute("flex","1");
      ch1.setAttribute("align","center");
        var ch2 = document.createElement("checkbox");
        ch2.setAttribute("id","is-default"+key);
        ch2.setAttribute("onclick","setDefault("+key+")");
        ch1.appendChild(ch2);
      ch.appendChild(ch1);
    obj.appendChild(ch);
  document.getElementById("wmn-accounts").appendChild(obj);
}
function getAccount(aKey){
  for each(var o in arAccounts){
    if(o.key==aKey)return o;
  }
  return null;
}
function setDefault(aKey){
  var o=getAccount(aKey);
  arDefault[o.host]=o.user;
  checkDefault();
  rebuildTree=true;
}
function setEnabled(disable,aKey){
  var o=getAccount(aKey);
  o.enabled=!disable;
  if(disable){
    if(arDefault[o.host]==o.user)arDefault[o.host]=null;
  }
  checkDefault();
  rebuildTree=true;
}
function checkDefault(){
  for each(var o in arAccounts){
    var em=document.getElementById("is-default"+o.key);
    if(o.enabled){
      if(!arDefault[o.host])arDefault[o.host]=o.user;
      var val=o.user==arDefault[o.host];
      em.setAttribute("checked",val);
      em.setAttribute("disabled",val);
    }else{
      em.setAttribute("checked",false);
      em.setAttribute("disabled",true);
    }
  }
}
function onSelect(aIndex){
  if(aIndex<0){
    document.getElementById("username").value="";
    document.getElementById("password").value="";
  }else{
    var o=arAccounts[aIndex];
    document.getElementById("wmn-hosts").value=o.host;
    document.getElementById("username").value=o.user;
    document.getElementById("password").value=o.passwd;
  }
}
function getString(aName) {
  var strbundle = document.getElementById("wmn-stringbundle");
  return strbundle.getString(aName);
}
function onAdd(){
  var user=document.getElementById("username").value;
  if(!user)return;
  var passwd=document.getElementById("password").value;
  var host=document.getElementById("wmn-hosts").value;
  if(hostStr[host]&&user.indexOf("@")==-1){
    user=user+"@"+hostStr[host];
  }
  ///find in list
  var index=-1;
  var o;
  for(var i in arAccounts){
    o=arAccounts[i];
    if(o.host==host&&o.user==user){
      index=i;
      break;
    }
  }
  if(index<0){//new account
    addItem(host,user,passwd,true);
    checkDefault();
  }else{//account exists.
    if(o.passwd==passwd)return;
    o.passwd=passwd;
    o.isNew=true;
  }
  accountsChanged=true;
}
function onDelete(){
  var obj=document.getElementById("wmn-accounts");
  var index=obj.selectedIndex;
  if(index<0)return;
  var o=arAccounts[index];
  arDeleted.push(o);
  obj.removeItemAt(index);
  arAccounts.splice(index,1);
  if(arDefault[o.host]==o.user){
    arDefault[o.host]=null;
    checkDefault();
  }
  accountsChanged=true;
}
function showAdvancedSound(){
  document.documentElement
          .openSubDialog("chrome://wm-notifier/content/notifications.xul",
                          "", null);
}

function checkMasterPasswords() {
  var tokendb = Components.classes["@mozilla.org/security/pk11tokendb;1"]
                    .createInstance(Ci.nsIPK11TokenDB);
  var token = tokendb.getInternalKeyToken();

  // There is no master password
  if (token.checkPassword(""))return true;

  // So there's a master password. But since checkPassword didn't succeed, we're logged out (per nsIPK11Token.idl).
  try {
    // Relogin and ask for the master password.
    token.login(true);  // 'true' means always prompt for token password. User will be prompted until
                        // clicking 'Cancel' or entering the correct password.
  } catch (e) {
    // An exception will be thrown if the user cancels the login prompt dialog.
    // User is also logged out of Software Security Device.
  }
  return token.isLoggedIn();
}
var main={
  addHost:function(hostID){
    var s=getHostName(hostID);
    if(s!=null){
      var obj=document.getElementById("wmn-hosts");
      obj.appendItem(s,hostID);
    }
  },
  removeHost:function(hostID){
    arDefault[hostID]=null;
    var em=document.getElementById("wmn-hosts");
    var list=em.firstChild.childNodes;
    for(var i=0;i<list.length;i++){
      var o=list[i];
      if(o.getAttribute("value")==hostID){
        em.removeItemAt(i);
        em.selectedIndex=0;
        break;
      }
    }
    var obj=document.getElementById("wmn-accounts");
    for(var i=0;i<arAccounts.length;i++){
      var o=arAccounts[i];
      if(o.host==hostID){
        obj.removeItemAt(i);
        arAccounts.splice(i,1);
        --i;
        accountsChanged=true;
      }
    }
  },
  showScripts:function(){
    document.documentElement
            .openSubDialog("chrome://wm-notifier/content/pref-script.xul",
                            "", this);
  }
}